#pragma once
// IWYU pragma: private <quark.h>

#include "Event.hpp"

namespace qk {

	class KeyEvent :
		public Event
	{
	public:
		inline int GetKeyCode() const { return keyCode; }

		EVENT_CLASS_CATEGORY(EventCategoryKeyboard | EventCategoryInput)

	protected:
		KeyEvent(int keyCode) :
			keyCode(keyCode)
		{ }

		int keyCode;
	};

	class KeyPressedEvent
		: public KeyEvent
	{
	public:
		KeyPressedEvent(int keyCode, int repeatCount) :
			KeyEvent(keyCode), repeatCount(repeatCount)
		{ }

		inline int GetRepeatCount() const { return repeatCount; }

		EVENT_CLASS_TYPE(KeyPressed)
	private:
		int repeatCount;
	};

	class KeyReleasedEvent
		: public KeyEvent
	{
	public:
		KeyReleasedEvent(int keyCode) :
			KeyEvent(keyCode)
		{ }

		EVENT_CLASS_TYPE(KeyReleased)
	};
}
